# module Curses

## Description¶ ↑

An implementation of the CRT screen handling and optimization library.

## Structures and such¶ ↑

### Classes¶ ↑

- Curses::Window - class with the means to draw a window or box

- Curses::MouseEvent - class for collecting mouse events

### Modules¶ ↑

Curses

  The curses implementation

Curses::Key

  Collection of constants for keypress events

## Examples¶ ↑

- hello.rb

      require "curses"

      def show_message(message)
        height = 5
        width  = message.length + 6
        top    = (Curses.lines - height) / 2
        left   = (Curses.cols - width) / 2
        win = Curses::Window.new(height, width, top, left)
        win.box("|", "-")
        win.setpos(2, 3)
        win.addstr(message)
        win.refresh
        win.getch
        win.close
      end

      Curses.init_screen
      begin
        Curses.crmode
        Curses.setpos((Curses.lines - 1) / 2, (Curses.cols - 11) / 2)
        Curses.addstr("Hit any key")
        Curses.refresh
        Curses.getch
        show_message("Hello, World!")
      ensure
        Curses.close_screen
      end

- rain.rb

      require "curses"

      def onsig(signal)
        Curses.close_screen
        exit signal
      end

      def place_string(y, x, string)
        Curses.setpos(y, x)
        Curses.addstr(string)
      end

      def cycle_index(index)
        (index + 1) % 5
      end

      %w[HUP INT QUIT TERM].each do |sig|
        unless trap(sig, "IGNORE") == "IGNORE"  # previous handler
          trap(sig) {|s| onsig(s) }
        end
      end

      Curses.init_screen
      Curses.nl
      Curses.noecho
      Curses.curs_set 0
      srand

      xpos, ypos = {}, {}
      x_range = 2..(Curses.cols - 3)
      y_range = 2..(Curses.lines - 3)
      (0..4).each do |i|
        xpos[i], ypos[i] = rand(x_range), rand(y_range)
      end

      i = 0
      loop do
        x, y = rand(x_range), rand(y_range)

        place_string(y, x, ".")

        place_string(ypos[i], xpos[i], "o")

        i = cycle_index(i)
        place_string(ypos[i], xpos[i], "O")

        i = cycle_index(i)
        place_string(ypos[i] - 1, xpos[i],      "-")
        place_string(ypos[i],     xpos[i] - 1, "|.|")
        place_string(ypos[i] + 1, xpos[i],      "-")

        i = cycle_index(i)
        place_string(ypos[i] - 2, xpos[i],       "-")
        place_string(ypos[i] - 1, xpos[i] - 1,  "/ \\")
        place_string(ypos[i],     xpos[i] - 2, "| O |")
        place_string(ypos[i] + 1, xpos[i] - 1, "\\ /")
        place_string(ypos[i] + 2, xpos[i],       "-")

        i = cycle_index(i)
        place_string(ypos[i] - 2, xpos[i],       " ")
        place_string(ypos[i] - 1, xpos[i] - 1,  "   ")
        place_string(ypos[i],     xpos[i] - 2, "     ")
        place_string(ypos[i] + 1, xpos[i] - 1,  "   ")
        place_string(ypos[i] + 2, xpos[i],       " ")

        xpos[i], ypos[i] = x, y

        Curses.refresh
        sleep(0.5)
      end

### Constants

ALL_MOUSE_EVENTS

  report all button state changes

  See ::getmouse

ALT_0
ALT_1
ALT_2
ALT_3
ALT_4
ALT_5
ALT_6
ALT_7
ALT_8
ALT_9
ALT_A
ALT_B
ALT_C
ALT_D
ALT_E
ALT_F
ALT_G
ALT_H
ALT_I
ALT_J
ALT_K
ALT_L
ALT_M
ALT_N
ALT_O
ALT_P
ALT_Q
ALT_R
ALT_S
ALT_T
ALT_U
ALT_V
ALT_W
ALT_X
ALT_Y
ALT_Z
A_ALTCHARSET

  Alternate character set

  See ::attrset

A_ATTRIBUTES

  Bit-mask to extract attributes

  See ::inch or Curses::Window#inch

A_BLINK

  Blinking

  See ::attrset

A_BOLD

  Extra bright or bold

  See ::attrset

A_CHARTEXT

  Bit-mask to extract a character

  See ::attrset

A_COLOR

  Bit-mask to extract color-pair field information

  See ::inch or Curses::Window#inch

A_DIM

  Half bright

  See ::attrset

A_HORIZONTAL

  horizontal highlight

  Check system curs_attr(3x) for support

A_INVIS

  Invisible or blank mode

  See ::attrset

A_LEFT

  left highlight

  Check system curs_attr(3x) for support

A_LOW

  low highlight

  Check system curs_attr(3x) for support

A_NORMAL

  Normal display (no highlight)

  See ::attrset

A_PROTECT

  Protected mode

  See ::attrset

A_REVERSE

  Reverse video

  See ::attrset

A_RIGHT

  right highlight

  Check system curs_attr(3x) for support

A_STANDOUT

  Best highlighting mode of the terminal.

  See ::attrset

A_TOP

  top highlight

  Check system curs_attr(3x) for support

A_UNDERLINE

  Underlining

  See ::attrset

A_VERTICAL

  vertical highlight

  Check system curs_attr(3x) for support

BUTTON1_CLICKED

  mouse button 1 clicked

  See ::getmouse

BUTTON1_DOUBLE_CLICKED

  mouse button 1 double clicked

  See ::getmouse

BUTTON1_PRESSED

  mouse button 1 down

  See ::getmouse

BUTTON1_RELEASED

  mouse button 1 up

  See ::getmouse

BUTTON1_TRIPLE_CLICKED

  mouse button 1 triple clicked

  See ::getmouse

BUTTON2_CLICKED

  mouse button 2 clicked

  See ::getmouse

BUTTON2_DOUBLE_CLICKED

  mouse button 2 double clicked

  See ::getmouse

BUTTON2_PRESSED

  mouse button 2 down

  See ::getmouse

BUTTON2_RELEASED

  mouse button 2 up

  See ::getmouse

BUTTON2_TRIPLE_CLICKED

  mouse button 2 triple clicked

  See ::getmouse

BUTTON3_CLICKED

  mouse button 3 clicked

  See ::getmouse

BUTTON3_DOUBLE_CLICKED

  mouse button 3 double clicked

  See ::getmouse

BUTTON3_PRESSED

  mouse button 3 down

  See ::getmouse

BUTTON3_RELEASED

  mouse button 3 up

  See ::getmouse

BUTTON3_TRIPLE_CLICKED

  mouse button 3 triple clicked

  See ::getmouse

BUTTON4_CLICKED

  mouse button 4 clicked

  See ::getmouse

BUTTON4_DOUBLE_CLICKED

  mouse button 4 double clicked

  See ::getmouse

BUTTON4_PRESSED

  mouse button 4 down

  See ::getmouse

BUTTON4_RELEASED

  mouse button 4 up

  See ::getmouse

BUTTON4_TRIPLE_CLICKED

  mouse button 4 triple clicked

  See ::getmouse

BUTTON_ALT

  alt was down during button state change

  See ::getmouse

BUTTON_CTRL

  control was down during button state change

  See ::getmouse

BUTTON_SHIFT

  shift was down during button state change

  See ::getmouse

COLORS

  Number of the colors available

COLOR_BLACK

  Value of the color black

COLOR_BLUE

  Value of the color blue

COLOR_CYAN

  Value of the color cyan

COLOR_GREEN

  Value of the color green

COLOR_MAGENTA

  Value of the color magenta

COLOR_RED

  Value of the color red

COLOR_WHITE

  Value of the color white

COLOR_YELLOW

  Value of the color yellow

KEY_A1

  Upper left of keypad

KEY_A3

  Upper right of keypad

KEY_B2

  Center of keypad

KEY_BACKSPACE

  Backspace

KEY_BEG

  Beginning key

KEY_BREAK

  Break key

KEY_BTAB

  Back tab key

KEY_C1

  Lower left of keypad

KEY_C3

  Lower right of keypad

KEY_CANCEL

  Cancel key

KEY_CATAB

  Clear all tabs

KEY_CLEAR

  Clear Screen

KEY_CLOSE

  Close key

KEY_COMMAND

  Cmd (command) key

KEY_COPY

  Copy key

KEY_CREATE

  Create key

KEY_CTAB

  Clear tab

KEY_DC

  Delete character

KEY_DL

  Delete line

KEY_DOWN

  the down arrow key

KEY_EIC

  Enter insert char mode

KEY_END

  End key

KEY_ENTER

  Enter or send

KEY_EOL

  Clear to end of line

KEY_EOS

  Clear to end of screen

KEY_EXIT

  Exit key

KEY_FIND

  Find key

KEY_HELP

  Help key

KEY_HOME

  Home key (upward+left arrow)

KEY_IC

  Insert char or enter insert mode

KEY_IL

  Insert line

KEY_LEFT

  the left arrow key

KEY_LL

  Home down or bottom (lower left)

KEY_MARK

  Mark key

KEY_MAX

  The maximum allowed curses key value.

KEY_MESSAGE

  Message key

KEY_MIN

  The minimum allowed curses key value.

KEY_MOUSE

  Mouse event read

KEY_MOVE

  Move key

KEY_NEXT

  Next object key

KEY_NPAGE

  Next page

KEY_OPEN

  Open key

KEY_OPTIONS

  Options key

KEY_PPAGE

  Previous page

KEY_PREVIOUS

  Previous object key

KEY_PRINT

  Print or copy

KEY_REDO

  Redo key

KEY_REFERENCE

  Reference key

KEY_REFRESH

  Refresh key

KEY_REPLACE

  Replace key

KEY_RESET

  Reset or hard reset

KEY_RESIZE

  Screen Resized

KEY_RESTART

  Restart key

KEY_RESUME

  Resume key

KEY_RIGHT

  the right arrow key

KEY_SAVE

  Save key

KEY_SBEG

  Shifted beginning key

KEY_SCANCEL

  Shifted cancel key

KEY_SCOMMAND

  Shifted command key

KEY_SCOPY

  Shifted copy key

KEY_SCREATE

  Shifted create key

KEY_SDC

  Shifted delete char key

KEY_SDL

  Shifted delete line key

KEY_SELECT

  Select key

KEY_SEND

  Shifted end key

KEY_SEOL

  Shifted clear line key

KEY_SEXIT

  Shifted exit key

KEY_SF

  Scroll 1 line forward

KEY_SFIND

  Shifted find key

KEY_SHELP

  Shifted help key

KEY_SHOME

  Shifted home key

KEY_SIC

  Shifted input key

KEY_SLEFT

  Shifted left arrow key

KEY_SMESSAGE

  Shifted message key

KEY_SMOVE

  Shifted move key

KEY_SNEXT

  Shifted next key

KEY_SOPTIONS

  Shifted options key

KEY_SPREVIOUS

  Shifted previous key

KEY_SPRINT

  Shifted print key

KEY_SR

  Scroll 1 line backward (reverse)

KEY_SREDO

  Shifted redo key

KEY_SREPLACE

  Shifted replace key

KEY_SRESET

  Soft (partial) reset

KEY_SRIGHT

  Shifted right arrow key

KEY_SRSUME

  Shifted resume key

KEY_SSAVE

  Shifted save key

KEY_SSUSPEND

  Shifted suspend key

KEY_STAB

  Set tab

KEY_SUNDO

  Shifted undo key

KEY_SUSPEND

  Suspend key

KEY_UNDO

  Undo key

KEY_UP

  the up arrow key

PDC_KEY_MODIFIER_ALT
PDC_KEY_MODIFIER_CONTROL
PDC_KEY_MODIFIER_NUMLOCK
PDC_KEY_MODIFIER_SHIFT
REPORT_MOUSE_POSITION

  report mouse movement

  See ::getmouse

REQ_BACK_PATTERN
REQ_CLEAR_PATTERN
REQ_DOWN_ITEM
REQ_FIRST_ITEM
REQ_LAST_ITEM
REQ_LEFT_ITEM
REQ_NEXT_ITEM
REQ_NEXT_MATCH
REQ_PREV_ITEM
REQ_PREV_MATCH
REQ_RIGHT_ITEM
REQ_SCR_DLINE
REQ_SCR_DPAGE
REQ_SCR_ULINE
REQ_SCR_UPAGE
REQ_TOGGLE_ITEM
REQ_UP_ITEM
VERSION

  Identifies curses library version.

  - “ncurses 5.9.20110404”

  - “PDCurses 3.4 - Public Domain 2008”

  - “curses (SVR4)” (System V curses)

  - “curses (unknown)” (The original BSD curses? NetBSD maybe.)

### Public Class Methods

ESCDELAY() click to toggle source

Returns the total time, in milliseconds, for which curses will await a character sequence, e.g., a function key

    static VALUE
    curses_escdelay_get(VALUE obj)
    {
        return INT2NUM(ESCDELAY);
    }

ESCDELAY=(value) click to toggle source

Sets the ::ESCDELAY to Integer `value`

    static VALUE
    curses_escdelay_set(VALUE obj, VALUE val)
    {
        ESCDELAY = NUM2INT(val);
        return INT2NUM(ESCDELAY);
    }

TABSIZE() click to toggle source

Returns the number of positions in a tab.

    static VALUE
    curses_tabsize_get(VALUE ojb)
    {
        return INT2NUM(TABSIZE);
    }

TABSIZE=(value) click to toggle source

Sets the ::TABSIZE to Integer `value`

    static VALUE
    curses_tabsize_set(VALUE obj, VALUE val)
    {
        TABSIZE = NUM2INT(val);
        return INT2NUM(TABSIZE);
    }

addch(ch) click to toggle source

Add a character `ch`, with attributes, then advance the cursor.

see also the system manual for curs_addch(3)

    static VALUE
    curses_addch(VALUE obj, VALUE ch)
    {
        curses_stdscr();
        addch(NUM2CH(ch));
        return Qnil;
    }

addstr(str) click to toggle source

add a string of characters `str`, to the window and advance cursor

    static VALUE
    curses_addstr(VALUE obj, VALUE str)
    {
        StringValue(str);
    #if defined(HAVE_ADDNWSTR) && defined(_WIN32)
        str = rb_str_export_to_enc(str, get_wide_encoding());
        curses_stdscr();
        if (!NIL_P(str)) {
            addnwstr((wchar_t *)RSTRING_PTR(str), RSTRING_LEN(str) / sizeof(wchar_t));
        }
    #else
        str = rb_str_export_to_enc(str, terminal_encoding);
        curses_stdscr();
        if (!NIL_P(str)) {
            addstr(StringValueCStr(str));
        }
    #endif
        return Qnil;
    }

assume_default_colors(p1, p2) click to toggle source

tells which colors to paint for color pair 0.

see also the system manual for default_colors(3)

    static VALUE
    curses_assume_default_colors(VALUE obj, VALUE fg, VALUE bg)
    {
        curses_stdscr();
        assume_default_colors(NUM2INT(fg), NUM2INT(bg));
        return Qnil;
    }

attroff(attrs) click to toggle source

Turns off the named attributes `attrs` without affecting any others.

See also Curses::Window#attrset for additional information.

    static VALUE
    curses_attroff(VALUE obj, VALUE attrs)
    {
        curses_stdscr();
        return window_attroff(rb_stdscr,attrs);
        /* return INT2FIX(attroff(NUM2INT(attrs))); */
    }

attron(attrs) click to toggle source

Turns on the named attributes `attrs` without turning any other attributes on or off.

See also Curses::Window#attrset for additional information.

    static VALUE
    curses_attron(VALUE obj, VALUE attrs)
    {
        curses_stdscr();
        return window_attron(rb_stdscr,attrs);
        /* return INT2FIX(attroff(NUM2INT(attrs))); */
    }

attrset(attrs) click to toggle source

Sets the current attributes of the given window to `attrs`.

see also Curses::Window#attrset

    static VALUE
    curses_attrset(VALUE obj, VALUE attrs)
    {
        curses_stdscr();
        return window_attrset(rb_stdscr,attrs);
        /* return INT2FIX(attroff(NUM2INT(attrs))); */
    }

beep() click to toggle source

Sounds an audible alarm on the terminal, if possible; otherwise it flashes the screen (visual bell).

see also ::flash

    static VALUE
    curses_beep(VALUE obj)
    {
    #ifdef HAVE_BEEP
        curses_stdscr();
        beep();
    #endif
        return Qnil;
    }

bkgd(ch) click to toggle source

Window background manipulation routines.

Set the background property of the current and then apply the character Integer `ch` setting to every character position in that window.

see also the system manual for curs_bkgd(3)

    static VALUE
    curses_bkgd(VALUE obj, VALUE ch)
    {
    #ifdef HAVE_BKGD
        curses_stdscr();
        return (bkgd(NUM2CHTYPE(ch)) == OK) ? Qtrue : Qfalse;
    #else
        return Qfalse;
    #endif
    }

bkgdset(ch) click to toggle source

Manipulate the background of the named window with character Integer `ch`

The background becomes a property of the character and moves with the character through any scrolling and insert/delete line/character operations.

see also the system manual for curs_bkgd(3)

    static VALUE
    curses_bkgdset(VALUE obj, VALUE ch)
    {
    #ifdef HAVE_BKGDSET
        curses_stdscr();
        bkgdset(NUM2CHTYPE(ch));
    #endif
        return Qnil;
    }

can_change_color?() click to toggle source

Returns `true` or `false` depending on whether the terminal can change color attributes

    static VALUE
    curses_can_change_color(VALUE obj)
    {
        curses_stdscr();
        return can_change_color() ? Qtrue : Qfalse;
    }

cbreak() click to toggle source

Put the terminal into cbreak mode.

Normally, the tty driver buffers typed characters until a newline or carriage return is typed. The ::cbreak routine disables line buffering and erase/kill character-processing (interrupt and flow control characters are unaffected), making characters typed by the user immediately available to the program.

The ::nocbreak routine returns the terminal to normal (cooked) mode.

Initially the terminal may or may not be in cbreak mode, as the mode is inherited; therefore, a program should call ::cbreak or ::nocbreak explicitly. Most interactive programs using curses set the cbreak mode. Note that ::cbreak overrides ::raw.

see also ::raw

    static VALUE
    curses_cbreak(VALUE obj)
    {
        curses_stdscr();
        cbreak();
        return Qnil;
    }

clear() click to toggle source

Clears every position on the screen completely, so that a subsequent call by ::refresh for the screen/window will be repainted from scratch.

    static VALUE
    curses_clear(VALUE obj)
    {
        curses_stdscr();
        wclear(stdscr);
        return Qnil;
    }

close_screen() click to toggle source

A program should always call ::close_screen before exiting or escaping from curses mode temporarily. This routine restores tty modes, moves the cursor to the lower left-hand corner of the screen and resets the terminal into the proper non-visual mode.

Calling ::refresh or ::doupdate after a temporary escape causes the program to resume visual mode.

    static VALUE
    curses_close_screen(void)
    {
        curses_stdscr();
    #ifdef HAVE_ISENDWIN
        if (!isendwin())
    #endif
            endwin();
        rb_stdscr = 0;
        return Qnil;
    }

closed?() click to toggle source

Returns `true` if the window/screen has been closed, without any subsequent ::refresh calls, returns `false` otherwise.

    static VALUE
    curses_closed(void)
    {
        curses_stdscr();
        if (isendwin()) {
            return Qtrue;
        }
        return Qfalse;
    }

clrtoeol() click to toggle source

Clears to the end of line, that the cursor is currently on.

    static VALUE
    curses_clrtoeol(void)
    {
        curses_stdscr();
        clrtoeol();
        return Qnil;
    }

color_content(color) click to toggle source

Returns an 3 item Array of the RGB values in `color`

    static VALUE
    curses_color_content(VALUE obj, VALUE color)
    {
        short r,g,b;

        curses_stdscr();
        color_content(NUM2INT(color),&r,&g,&b);
        return rb_ary_new3(3,INT2FIX(r),INT2FIX(g),INT2FIX(b));
    }

color_pair(attrs) click to toggle source

Sets the color pair attributes to `attrs`.

This should be equivalent to ::attrset(COLOR_PAIR(`attrs`))

TODO: validate that equivalency

    static VALUE
    curses_color_pair(VALUE obj, VALUE attrs)
    {
        return INT2FIX(COLOR_PAIR(NUM2INT(attrs)));
    }

color_pairs() click to toggle source

Returns the COLOR_PAIRS available, if the curses library supports it.

    static VALUE
    curses_color_pairs(VALUE obj)
    {
        return INT2FIX(COLOR_PAIRS);
    }

colors() click to toggle source

returns COLORS

    static VALUE
    curses_colors(VALUE obj)
    {
        return INT2FIX(COLORS);
    }

cols() click to toggle source

Returns the number of columns on the screen

    static VALUE
    curses_cols(void)
    {
        return INT2FIX(COLS);
    }

crmode() click to toggle source

Put the terminal into cbreak mode.

Normally, the tty driver buffers typed characters until a newline or carriage return is typed. The ::cbreak routine disables line buffering and erase/kill character-processing (interrupt and flow control characters are unaffected), making characters typed by the user immediately available to the program.

The ::nocbreak routine returns the terminal to normal (cooked) mode.

Initially the terminal may or may not be in cbreak mode, as the mode is inherited; therefore, a program should call ::cbreak or ::nocbreak explicitly. Most interactive programs using curses set the cbreak mode. Note that ::cbreak overrides ::raw.

see also ::raw

    static VALUE
    curses_cbreak(VALUE obj)
    {
        curses_stdscr();
        cbreak();
        return Qnil;
    }

curs_set(visibility) click to toggle source

Sets Cursor Visibility. 0: invisible 1: visible 2: very visible

    static VALUE
    curses_curs_set(VALUE obj, VALUE visibility)
    {
    #ifdef HAVE_CURS_SET
        int n;
        curses_stdscr();
        return (n = curs_set(NUM2INT(visibility)) != ERR) ? INT2FIX(n) : Qnil;
    #else
        return Qnil;
    #endif
    }

def_prog_mode() click to toggle source

Save the current terminal modes as the “program” state for use by the ::reset_prog_mode

This is done automatically by ::init_screen

    static VALUE
    curses_def_prog_mode(VALUE obj)
    {
        curses_stdscr();
        return def_prog_mode() == OK ? Qtrue : Qfalse;
    }

delch() click to toggle source

Delete the character under the cursor

    static VALUE
    curses_delch(VALUE obj)
    {
        curses_stdscr();
        delch();
        return Qnil;
    }

deleteln() click to toggle source

Delete the line under the cursor.

    static VALUE
    curses_deleteln(VALUE obj)
    {
        curses_stdscr();
    #if defined(HAVE_DELETELN) || defined(deleteln)
        deleteln();
    #endif
        return Qnil;
    }

doupdate() click to toggle source

Refreshes the windows and lines.

::doupdate allows multiple updates with more efficiency than ::refresh alone.

    static VALUE
    curses_doupdate(VALUE obj)
    {
        curses_stdscr();
    #ifdef HAVE_DOUPDATE
        doupdate();
    #else
        refresh();
    #endif
        return Qnil;
    }

echo() click to toggle source

Enables characters typed by the user to be echoed by ::getch as they are typed.

    static VALUE
    curses_echo(VALUE obj)
    {
        curses_stdscr();
        echo();
        return Qnil;
    }

erase() click to toggle source

Erase the screen.

    static VALUE
    curses_erase(VALUE obj)
    {
        curses_stdscr();
        werase(stdscr);
        return Qnil;
    }

flash() click to toggle source

Flashes the screen, for visual alarm on the terminal, if possible; otherwise it sounds the alert.

see also ::beep

    static VALUE
    curses_flash(VALUE obj)
    {
    #ifdef HAVE_FLASH
        curses_stdscr();
        flash();
    #endif
        return Qnil;
    }

get_char() click to toggle source

Read and returns a character or function key from the window. A single or multibyte character is represented by a String, and a function key is represented by an Integer. Returns nil if no input is ready.

See Curses::Key to all the function KEY_* available

    static VALUE
    curses_get_char(VALUE obj)
    {
    #ifdef HAVE_GET_WCH
        struct get_wch_arg arg;

        curses_stdscr();
        rb_thread_call_without_gvl(get_wch_func, &arg, RUBY_UBF_IO, 0);
        switch (arg.retval) {
        case OK:
            return keyboard_uint_chr(arg.ch);
        case KEY_CODE_YES:
            return UINT2NUM(arg.ch);
        }
        return Qnil;
    #else
        int c;

        curses_stdscr();
        rb_thread_call_without_gvl(getch_func, &c, RUBY_UBF_IO, 0);
        if (c > 0xff) {
            return INT2NUM(c);
        }
        else if (c >= 0) {
            return keyboard_uint_chr(c);
        }
        else {
            return Qnil;
        }
    #endif
    }

get_key_modifiers() click to toggle source

    static VALUE
    curses_get_key_modifiers(VALUE obj)
    {
        return ULONG2NUM(PDC_get_key_modifiers());
    }

getch() click to toggle source

Read and returns a character from the window.

See Curses::Key to all the function KEY_* available

    static VALUE
    curses_getch(VALUE obj)
    {
        int c;

        curses_stdscr();
        rb_thread_call_without_gvl(getch_func, &c, RUBY_UBF_IO, 0);
        if (c == EOF) return Qnil;
        if (rb_isprint(c)) {
            char ch = (char)c;

            return rb_external_str_new_with_enc(&ch, 1, keyboard_encoding);
        }
        return UINT2NUM(c);
    }

getmouse() click to toggle source

Returns coordinates of the mouse.

This will read and pop the mouse event data off the queue

See the BUTTON*, ALL_MOUSE_EVENTS and REPORT_MOUSE_POSITION constants, to examine the mask of the event

    static VALUE
    curses_getmouse(VALUE obj)
    {
        struct mousedata *mdata;
        VALUE val;

        curses_stdscr();
        val = TypedData_Make_Struct(cMouseEvent,struct mousedata,
                                    &mousedata_type,mdata);
        mdata->mevent = (MEVENT*)xmalloc(sizeof(MEVENT));
        return (getmouse(mdata->mevent) == OK) ? val : Qnil;
    }

getstr() click to toggle source

This is equivalent to a series f Curses::Window#getch calls

    static VALUE
    curses_getstr(VALUE obj)
    {
        char rtn[GETSTR_BUF_SIZE];

        curses_stdscr();
        rb_thread_call_without_gvl(getstr_func, rtn, RUBY_UBF_IO, 0);
        return rb_external_str_new_with_enc(rtn, strlen(rtn), keyboard_encoding);
    }

has_colors?() click to toggle source

Returns `true` or `false` depending on whether the terminal has color capabilities.

    static VALUE
    curses_has_colors(VALUE obj)
    {
        curses_stdscr();
        return has_colors() ? Qtrue : Qfalse;
    }

inch() click to toggle source

Returns the character at the current position.

    static VALUE
    curses_inch(VALUE obj)
    {
        curses_stdscr();
        return CH2FIX(inch());
    }

init_color(color, r, g, b) click to toggle source

Changes the definition of a color. It takes four arguments:

- the number of the color to be changed, `color`

- the amount of red, `r`

- the amount of green, `g`

- the amount of blue, `b`

The value of the first argument must be between 0 and COLORS. (See the section Colors for the default color index.) Each of the last three arguments must be a value between 0 and 1000. When ::init_color is used, all occurrences of that color on the screen immediately change to the new definition.

    static VALUE
    curses_init_color(VALUE obj, VALUE color, VALUE r, VALUE g, VALUE b)
    {
        /* may have to raise exception on ERR */
        curses_stdscr();
        return (init_color(NUM2INT(color),NUM2INT(r),
                           NUM2INT(g),NUM2INT(b)) == OK) ? Qtrue : Qfalse;
    }

init_pair(pair, f, b) click to toggle source

Changes the definition of a color-pair.

It takes three arguments: the number of the color-pair to be changed `pair`, the foreground color number `f`, and the background color number `b`.

If the color-pair was previously initialized, the screen is refreshed and all occurrences of that color-pair are changed to the new definition.

    static VALUE
    curses_init_pair(VALUE obj, VALUE pair, VALUE f, VALUE b)
    {
        /* may have to raise exception on ERR */
        curses_stdscr();
        return (init_pair(NUM2INT(pair),NUM2INT(f),NUM2INT(b)) == OK) ? Qtrue : Qfalse;
    }

init_screen() click to toggle source

Initialize a standard screen

see also ::stdscr

    static VALUE
    curses_init_screen(void)
    {
        if (rb_stdscr) return rb_stdscr;
        initscr();
        if (stdscr == 0) {
            rb_raise(rb_eRuntimeError, "can't initialize curses");
        }
        rb_set_end_proc(curses_finalize, 0);
        clear();
        rb_stdscr = prep_window(cWindow, stdscr);
        return rb_stdscr;
    }

insch(ch) click to toggle source

Insert a character `ch`, before the cursor.

    static VALUE
    curses_insch(VALUE obj, VALUE ch)
    {
        curses_stdscr();
        insch(NUM2CH(ch));
        return Qnil;
    }

insertln() click to toggle source

Inserts a line above the cursor, and the bottom line is lost

    static VALUE
    curses_insertln(VALUE obj)
    {
        curses_stdscr();
    #if defined(HAVE_INSERTLN) || defined(insertln)
        insertln();
    #endif
        return Qnil;
    }

keyboard_encoding click to toggle source

Returns the encoding for keyboard input.

    static VALUE
    curses_get_keyboard_encoding(VALUE obj)
    {
        return rb_enc_from_encoding(keyboard_encoding);
    }

keyboard_encoding = encoding click to toggle source

Sets the encoding for keyboard input.

    static VALUE
    curses_set_keyboard_encoding(VALUE obj, VALUE enc)
    {
        keyboard_encoding = rb_to_encoding(enc);
        return enc;
    }

keyname(c) click to toggle source

Returns the character string corresponding to key `c`

    static VALUE
    curses_keyname(VALUE obj, VALUE c)
    {
    #ifdef HAVE_KEYNAME
        int cc = curses_char(c);
        const char *name;

        curses_stdscr();
        name = keyname(cc);
        if (name) {
            return rb_str_new_cstr(name);
        }
        else {
            return Qnil;
        }
    #else
        return Qnil;
    #endif
    }

lines() click to toggle source

Returns the number of lines on the screen

    static VALUE
    curses_lines(void)
    {
        return INT2FIX(LINES);
    }

mouseinterval(interval) click to toggle source

The ::mouseinterval function sets the maximum time (in thousands of a second) that can elapse between press and release events for them to be recognized as a click.

Use ::mouseinterval to disable click resolution. This function returns the previous interval value.

Use ::mouseinterval to obtain the interval without altering it.

The default is one sixth of a second.

    static VALUE
    curses_mouseinterval(VALUE obj, VALUE interval)
    {
        curses_stdscr();
        return mouseinterval(NUM2INT(interval)) ? Qtrue : Qfalse;
    }

mousemask(mask) click to toggle source

Returns the `mask` of the reportable events

    static VALUE
    curses_mousemask(VALUE obj, VALUE mask)
    {
        curses_stdscr();
        return INT2NUM(mousemask(NUM2UINT(mask),NULL));
    }

nl() click to toggle source

Enable the underlying display device to translate the return key into newline on input, and whether it translates newline into return and line-feed on output (in either case, the call ::addch('n') does the equivalent of return and line feed on the virtual screen).

Initially, these translations do occur. If you disable them using ::nonl, curses will be able to make better use of the line-feed capability, resulting in faster cursor motion. Also, curses will then be able to detect the return key.

    static VALUE
    curses_nl(VALUE obj)
    {
        curses_stdscr();
        nl();
        return Qnil;
    }

nocbreak() click to toggle source

Put the terminal into normal mode (out of cbreak mode).

See ::cbreak for more detail.

    static VALUE
    curses_nocbreak(VALUE obj)
    {
        curses_stdscr();
        nocbreak();
        return Qnil;
    }

nocrmode() click to toggle source

Put the terminal into normal mode (out of cbreak mode).

See ::cbreak for more detail.

    static VALUE
    curses_nocbreak(VALUE obj)
    {
        curses_stdscr();
        nocbreak();
        return Qnil;
    }

noecho() click to toggle source

Disables characters typed by the user to be echoed by ::getch as they are typed.

    static VALUE
    curses_noecho(VALUE obj)
    {
        curses_stdscr();
        noecho();
        return Qnil;
    }

nonl() click to toggle source

Disable the underlying display device to translate the return key into newline on input

See ::nl for more detail

    static VALUE
    curses_nonl(VALUE obj)
    {
        curses_stdscr();
        nonl();
        return Qnil;
    }

noraw() click to toggle source

Put the terminal out of raw mode.

see ::raw for more detail

    static VALUE
    curses_noraw(VALUE obj)
    {
        curses_stdscr();
        noraw();
        return Qnil;
    }

pair_content(pair) click to toggle source

Returns a 2 item Array, with the foreground and background color, in `pair`

    static VALUE
    curses_pair_content(VALUE obj, VALUE pair)
    {
        short f,b;

        curses_stdscr();
        pair_content(NUM2INT(pair),&f,&b);
        return rb_ary_new3(2,INT2FIX(f),INT2FIX(b));
    }

pair_number(attrs) click to toggle source

Returns the Fixnum color pair number of attributes `attrs`.

    static VALUE
    curses_pair_number(VALUE obj, VALUE attrs)
    {
        curses_stdscr();
        return INT2FIX(PAIR_NUMBER(NUM2LONG(attrs)));
    }

raw() click to toggle source

Put the terminal into raw mode.

Raw mode is similar to ::cbreak mode, in that characters typed are immediately passed through to the user program.

The differences are that in raw mode, the interrupt, quit, suspend, and flow control characters are all passed through uninterpreted, instead of generating a signal. The behavior of the BREAK key depends on other bits in the tty driver that are not set by curses.

    static VALUE
    curses_raw(VALUE obj)
    {
        curses_stdscr();
        raw();
        return Qnil;
    }

refresh() click to toggle source

Refreshes the windows and lines.

    static VALUE
    curses_refresh(VALUE obj)
    {
        curses_stdscr();
        refresh();
        return Qnil;
    }

reset_prog_mode() click to toggle source

Reset the current terminal modes to the saved state by the ::def_prog_mode

This is done automatically by ::close_screen

    static VALUE
    curses_reset_prog_mode(VALUE obj)
    {
        curses_stdscr();
        return reset_prog_mode() == OK ? Qtrue : Qfalse;
    }

resizeterm(lines, cols) click to toggle source

Resize the current term to Fixnum `lines` and Fixnum `cols`

    static VALUE
    curses_resizeterm(VALUE obj, VALUE lin, VALUE col)
    {
    #if defined(HAVE_RESIZETERM)
        curses_stdscr();
        return (resizeterm(NUM2INT(lin),NUM2INT(col)) == OK) ? Qtrue : Qfalse;
    #else
        return Qnil;
    #endif
    }

resizeterm(lines, cols) click to toggle source

Resize the current term to Fixnum `lines` and Fixnum `cols`

    static VALUE
    curses_resizeterm(VALUE obj, VALUE lin, VALUE col)
    {
    #if defined(HAVE_RESIZETERM)
        curses_stdscr();
        return (resizeterm(NUM2INT(lin),NUM2INT(col)) == OK) ? Qtrue : Qfalse;
    #else
        return Qnil;
    #endif
    }

return_key_modifiers(p1) click to toggle source

    static VALUE
    curses_return_key_modifiers(VALUE obj, VALUE flag)
    {
        return INT2NUM(PDC_return_key_modifiers(RTEST(flag)));
    }

save_key_modifiers(p1) click to toggle source

    static VALUE
    curses_save_key_modifiers(VALUE obj, VALUE flag)
    {
        return INT2NUM(PDC_save_key_modifiers(RTEST(flag)));
    }

scrl(num) click to toggle source

Scrolls the current window Fixnum `num` lines. The current cursor position is not changed.

For positive `num`, it scrolls up.

For negative `num`, it scrolls down.

    static VALUE
    curses_scrl(VALUE obj, VALUE n)
    {
        /* may have to raise exception on ERR */
    #ifdef HAVE_SCRL
        curses_stdscr();
        return (scrl(NUM2INT(n)) == OK) ? Qtrue : Qfalse;
    #else
        return Qfalse;
    #endif
    }

setpos(y, x) click to toggle source

A setter for the position of the cursor, using coordinates `x` and `y`

    static VALUE
    curses_setpos(VALUE obj, VALUE y, VALUE x)
    {
        curses_stdscr();
        move(NUM2INT(y), NUM2INT(x));
        return Qnil;
    }

setscrreg(top, bottom) click to toggle source

Set a software scrolling region in a window. `top` and `bottom` are lines numbers of the margin.

If this option and Curses.scrollok are enabled, an attempt to move off the bottom margin line causes all lines in the scrolling region to scroll one line in the direction of the first line. Only the text of the window is scrolled.

    static VALUE
    curses_setscrreg(VALUE obj, VALUE top, VALUE bottom)
    {
        /* may have to raise exception on ERR */
    #ifdef HAVE_SETSCRREG
        curses_stdscr();
        return (setscrreg(NUM2INT(top), NUM2INT(bottom)) == OK) ? Qtrue : Qfalse;
    #else
        return Qfalse;
    #endif
    }

standend() click to toggle source

Enables the Normal display (no highlight)

This is equivalent to ::attron

see also Curses::Window#attrset for additional information.

    static VALUE
    curses_standend(VALUE obj)
    {
        curses_stdscr();
        standend();
        return Qnil;
    }

standout() click to toggle source

Enables the best highlighting mode of the terminal.

This is equivalent to Curses:Window.attron(A_STANDOUT)

see also Curses::Window#attrset additional information

    static VALUE
    curses_standout(VALUE obj)
    {
        curses_stdscr();
        standout();
        return Qnil;
    }

start_color() click to toggle source

Initializes the color attributes, for terminals that support it.

This must be called, in order to use color attributes. It is good practice to call it just after ::init_screen

    static VALUE
    curses_start_color(VALUE obj)
    {
        /* may have to raise exception on ERR */
        curses_stdscr();
        return (start_color() == OK) ? Qtrue : Qfalse;
    }

stdscr() click to toggle source

The Standard Screen.

Upon initializing curses, a default window called stdscr, which is the size of the terminal screen, is created.

Many curses functions use this window.

    #define curses_stdscr curses_init_screen

terminal_encoding click to toggle source

Returns the encoding for terminal output.

    static VALUE
    curses_get_terminal_encoding(VALUE obj)
    {
        return rb_enc_from_encoding(terminal_encoding);
    }

terminal_encoding = encoding click to toggle source

Sets the encoding for terminal output.

    static VALUE
    curses_set_terminal_encoding(VALUE obj, VALUE enc)
    {
        terminal_encoding = rb_to_encoding(enc);
        return enc;
    }

timeout=(delay) click to toggle source

Sets block and non-blocking reads for the window.

- If delay is negative, blocking read is used (i.e., waits indefinitely for input).

- If delay is zero, then non-blocking read is used (i.e., read returns ERR if no input is waiting).

- If delay is positive, then read blocks for delay milliseconds, and returns ERR if there is still no input.

    static VALUE
    curses_timeout(VALUE obj, VALUE delay)
    {
        curses_stdscr();
        timeout(NUM2INT(delay));
        return Qnil;
    }

unget_char(ch) click to toggle source

Places `ch` back onto the input queue to be returned by the next call to ::get_char etc.

There is just one input queue for all windows.

    static VALUE
    curses_unget_char(VALUE obj, VALUE ch)
    {
        ID id_ord;
        unsigned int c;

        curses_stdscr();
        if (FIXNUM_P(ch)) {
            ungetch(NUM2UINT(ch));
        }
        else {
            StringValue(ch);
            CONST_ID(id_ord, "ord");
            c = NUM2UINT(rb_funcall(ch, id_ord, 0));
    #ifdef HAVE_UNGET_WCH
            unget_wch(c);
    #else
            if (c > 0xff) {
                rb_raise(rb_eRangeError, "Out of range: %u", c);
            }
            ungetch(c);
    #endif
        }
        return Qnil;
    }

ungetch(ch) click to toggle source

Places `ch` back onto the input queue to be returned by the next call to ::getch.

There is just one input queue for all windows.

    static VALUE
    curses_ungetch(VALUE obj, VALUE ch)
    {
        int c = curses_char(ch);
        curses_stdscr();
        ungetch(c);
        return Qnil;
    }

ungetmouse(p1) click to toggle source

It pushes a KEY_MOUSE event onto the input queue, and associates with that event the given state data and screen-relative character-cell coordinates.

The ::ungetmouse function behaves analogously to ::ungetch.

    static VALUE
    curses_ungetmouse(VALUE obj, VALUE mevent)
    {
        struct mousedata *mdata;

        curses_stdscr();
        GetMOUSE(mevent,mdata);
        return (ungetmouse(mdata->mevent) == OK) ? Qtrue : Qfalse;
    }

use_default_colors() click to toggle source

tells the curses library to use terminal's default colors.

see also the system manual for default_colors(3)

    static VALUE
    curses_use_default_colors(VALUE obj)
    {
        curses_stdscr();
        use_default_colors();
        return Qnil;
    }